org.apache.poi.hwpf.model.types

## Class PAPAbstractType

- java.lang.Object
- - org.apache.poi.hwpf.model.types.PAPAbstractType

- Direct Known Subclasses:
    ParagraphProperties

      @Internal
      public abstract class PAPAbstractType
      extends java.lang.Object

  Paragraph Properties.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static byte` | `BRCL_DOUBLE`
    `protected static byte` | `BRCL_SHADOW`
    `protected static byte` | `BRCL_SINGLE`
    `protected static byte` | `BRCL_THICK`
    `protected static byte` | `BRCP_BAR_TO_LEFT_OF_PARAGRAPH`
    `protected static byte` | `BRCP_BORDER_ABOVE`
    `protected static byte` | `BRCP_BORDER_BELOW`
    `protected static byte` | `BRCP_BOX_AROUND`
    `protected static byte` | `BRCP_NONE`
    `protected int` | `field_1_istd`
    `protected boolean` | `field_10_fNoLnn`
    `protected LineSpacingDescriptor` | `field_11_lspd`
    `protected int` | `field_12_dyaBefore`
    `protected int` | `field_13_dyaAfter`
    `protected boolean` | `field_14_fInTable`
    `protected boolean` | `field_15_finTableW97`
    `protected boolean` | `field_16_fTtp`
    `protected int` | `field_17_dxaAbs`
    `protected int` | `field_18_dyaAbs`
    `protected int` | `field_19_dxaWidth`
    `protected boolean` | `field_2_fSideBySide`
    `protected boolean` | `field_20_fBrLnAbove`
    `protected boolean` | `field_21_fBrLnBelow`
    `protected byte` | `field_22_pcVert`
    `protected byte` | `field_23_pcHorz`
    `protected byte` | `field_24_wr`
    `protected boolean` | `field_25_fNoAutoHyph`
    `protected int` | `field_26_dyaHeight`
    `protected boolean` | `field_27_fMinHeight`
    `protected DropCapSpecifier` | `field_28_dcs`
    `protected int` | `field_29_dyaFromText`
    `protected boolean` | `field_3_fKeep`
    `protected int` | `field_30_dxaFromText`
    `protected boolean` | `field_31_fLocked`
    `protected boolean` | `field_32_fWidowControl`
    `protected boolean` | `field_33_fKinsoku`
    `protected boolean` | `field_34_fWordWrap`
    `protected boolean` | `field_35_fOverflowPunct`
    `protected boolean` | `field_36_fTopLinePunct`
    `protected boolean` | `field_37_fAutoSpaceDE`
    `protected boolean` | `field_38_fAutoSpaceDN`
    `protected int` | `field_39_wAlignFont`
    `protected boolean` | `field_4_fKeepFollow`
    `protected short` | `field_40_fontAlign`
    `protected byte` | `field_41_lvl`
    `protected boolean` | `field_42_fBiDi`
    `protected boolean` | `field_43_fNumRMIns`
    `protected boolean` | `field_44_fCrLf`
    `protected boolean` | `field_45_fUsePgsuSettings`
    `protected boolean` | `field_46_fAdjustRight`
    `protected int` | `field_47_itap`
    `protected boolean` | `field_48_fInnerTableCell`
    `protected boolean` | `field_49_fOpenTch`
    `protected boolean` | `field_5_fPageBreakBefore`
    `protected boolean` | `field_50_fTtpEmbedded`
    `protected short` | `field_51_dxcRight`
    `protected short` | `field_52_dxcLeft`
    `protected short` | `field_53_dxcLeft1`
    `protected boolean` | `field_54_fDyaBeforeAuto`
    `protected boolean` | `field_55_fDyaAfterAuto`
    `protected int` | `field_56_dxaRight`
    `protected int` | `field_57_dxaLeft`
    `protected int` | `field_58_dxaLeft1`
    `protected byte` | `field_59_jc`
    `protected byte` | `field_6_brcl`
    `protected BorderCode` | `field_60_brcTop`
    `protected BorderCode` | `field_61_brcLeft`
    `protected BorderCode` | `field_62_brcBottom`
    `protected BorderCode` | `field_63_brcRight`
    `protected BorderCode` | `field_64_brcBetween`
    `protected BorderCode` | `field_65_brcBar`
    `protected ShadingDescriptor` | `field_66_shd`
    `protected byte[]` | `field_67_anld`
    `protected byte[]` | `field_68_phe`
    `protected boolean` | `field_69_fPropRMark`
    `protected byte` | `field_7_brcp`
    `protected int` | `field_70_ibstPropRMark`
    `protected DateAndTime` | `field_71_dttmPropRMark`
    `protected int` | `field_72_itbdMac`
    `protected int[]` | `field_73_rgdxaTab`
    `protected TabDescriptor[]` | `field_74_rgtbd`
    `protected byte[]` | `field_75_numrm`
    `protected byte[]` | `field_76_ptap`
    `protected boolean` | `field_77_fNoAllowOverlap`
    `protected long` | `field_78_ipgp`
    `protected long` | `field_79_rsid`
    `protected byte` | `field_8_ilvl`
    `protected int` | `field_9_ilfo`
    `protected static boolean` | `FMINHEIGHT_AT_LEAST`
    `protected static boolean` | `FMINHEIGHT_EXACT`
    `protected static byte` | `WALIGNFONT_AUTO`
    `protected static byte` | `WALIGNFONT_CENTERED`
    `protected static byte` | `WALIGNFONT_HANGING`
    `protected static byte` | `WALIGNFONT_ROMAN`
    `protected static byte` | `WALIGNFONT_VARIABLE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `PAPAbstractType()`
    `protected` | `PAPAbstractType(PAPAbstractType other)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `byte[]` | `getAnld()` Get the anld field for the PAP record.
    `BorderCode` | `getBrcBar()` Get the brcBar field for the PAP record.
    `BorderCode` | `getBrcBetween()` Get the brcBetween field for the PAP record.
    `BorderCode` | `getBrcBottom()` Get the brcBottom field for the PAP record.
    `byte` | `getBrcl()` Border line style.
    `BorderCode` | `getBrcLeft()` Get the brcLeft field for the PAP record.
    `byte` | `getBrcp()` Rectangle border codes.
    `BorderCode` | `getBrcRight()` Get the brcRight field for the PAP record.
    `BorderCode` | `getBrcTop()` Get the brcTop field for the PAP record.
    `DropCapSpecifier` | `getDcs()` Get the dcs field for the PAP record.
    `DateAndTime` | `getDttmPropRMark()` Get the dttmPropRMark field for the PAP record.
    `int` | `getDxaAbs()` Get the dxaAbs field for the PAP record.
    `int` | `getDxaFromText()` Horizontal distance between text and absolutely positioned object.
    `int` | `getDxaLeft()` Get the dxaLeft field for the PAP record.
    `int` | `getDxaLeft1()` Get the dxaLeft1 field for the PAP record.
    `int` | `getDxaRight()` Get the dxaRight field for the PAP record.
    `int` | `getDxaWidth()` Get the dxaWidth field for the PAP record.
    `short` | `getDxcLeft()` Left indent in character units.
    `short` | `getDxcLeft1()` First line indent in character units.
    `short` | `getDxcRight()` Right indent in character units.
    `int` | `getDyaAbs()` Get the dyaAbs field for the PAP record.
    `int` | `getDyaAfter()` Space after paragraph.
    `int` | `getDyaBefore()` Space before paragraph.
    `int` | `getDyaFromText()` Vertical distance between text and absolutely positioned object.
    `int` | `getDyaHeight()` Get the dyaHeight field for the PAP record.
    `boolean` | `getFAdjustRight()` Get the fAdjustRight field for the PAP record.
    `boolean` | `getFAutoSpaceDE()` auto space East Asian and alphabetic characters.
    `boolean` | `getFAutoSpaceDN()` auto space East Asian and numeric characters.
    `boolean` | `getFBiDi()` Get the fBiDi field for the PAP record.
    `boolean` | `getFBrLnAbove()` Get the fBrLnAbove field for the PAP record.
    `boolean` | `getFBrLnBelow()` Get the fBrLnBelow field for the PAP record.
    `boolean` | `getFCrLf()` Get the fCrLf field for the PAP record.
    `boolean` | `getFDyaAfterAuto()` Vertical spacing after is automatic.
    `boolean` | `getFDyaBeforeAuto()` Vertical spacing before is automatic.
    `boolean` | `getFInnerTableCell()` When 1, the end of paragraph mark is really an end of cell mark for a nested table cell.
    `boolean` | `getFInTable()` Paragraph is in table flag.
    `boolean` | `getFinTableW97()` Archaic paragraph is in table flag.
    `boolean` | `getFKeep()` Get the fKeep field for the PAP record.
    `boolean` | `getFKeepFollow()` Get the fKeepFollow field for the PAP record.
    `boolean` | `getFKinsoku()` apply Kinsoku rules when performing line wrapping.
    `boolean` | `getFLocked()` Anchor of an absolutely positioned frame is locked.
    `boolean` | `getFMinHeight()` Minimum height is exact or auto.
    `boolean` | `getFNoAllowOverlap()` When 1, absolutely positioned paragraph cannot overlap with another paragraph.
    `boolean` | `getFNoAutoHyph()` Get the fNoAutoHyph field for the PAP record.
    `boolean` | `getFNoLnn()` No line numbering.
    `boolean` | `getFNumRMIns()` Get the fNumRMIns field for the PAP record.
    `short` | `getFontAlign()` Used internally by Word.
    `boolean` | `getFOpenTch()` Ensure the Table Cell char doesn't show up as zero height.
    `boolean` | `getFOverflowPunct()` apply overflow punctuation rules when performing line wrapping.
    `boolean` | `getFPageBreakBefore()` Get the fPageBreakBefore field for the PAP record.
    `boolean` | `getFPropRMark()` Get the fPropRMark field for the PAP record.
    `boolean` | `getFSideBySide()` Get the fSideBySide field for the PAP record.
    `boolean` | `getFTopLinePunct()` perform top line punctuation processing.
    `boolean` | `getFTtp()` Table trailer paragraph (last in table row).
    `boolean` | `getFTtpEmbedded()` Word 97 compatibility indicates this end of paragraph mark is really an end of row marker for a nested table.
    `boolean` | `getFUsePgsuSettings()` Get the fUsePgsuSettings field for the PAP record.
    `boolean` | `getFWidowControl()` 1, Word will prevent widowed lines in this paragraph from being placed at the beginning of a page.
    `boolean` | `getFWordWrap()` perform word wrap.
    `int` | `getIbstPropRMark()` Get the ibstPropRMark field for the PAP record.
    `int` | `getIlfo()` "A 16-bit signed integer value that is used to determine which list contains the paragraph.
    `byte` | `getIlvl()` List level if non-zero.
    `long` | `getIpgp()` HTML DIV ID for this paragraph.
    `int` | `getIstd()` Index to style descriptor.
    `int` | `getItap()` Table nesting level.
    `int` | `getItbdMac()` Number of tabs stops defined for paragraph.
    `byte` | `getJc()` Get the jc field for the PAP record.
    `LineSpacingDescriptor` | `getLspd()` Line spacing descriptor.
    `byte` | `getLvl()` Outline level.
    `byte[]` | `getNumrm()` Get the numrm field for the PAP record.
    `byte` | `getPcHorz()` Get the pcHorz field for the PAP record.
    `byte` | `getPcVert()` Get the pcVert field for the PAP record.
    `byte[]` | `getPhe()` Get the phe field for the PAP record.
    `byte[]` | `getPtap()` Get the ptap field for the PAP record.
    `int[]` | `getRgdxaTab()` Array of positions of itbdMac tab stops.
    `TabDescriptor[]` | `getRgtbd()` Array of itbdMac tab descriptors.
    `long` | `getRsid()` Save ID for last time this PAP was revised.
    `ShadingDescriptor` | `getShd()` Get the shd field for the PAP record.
    `int` | `getWAlignFont()` Get the wAlignFont field for the PAP record.
    `byte` | `getWr()` Get the wr field for the PAP record.
    `boolean` | `isFBackward()`
    `boolean` | `isFRotateFont()`
    `boolean` | `isFVertical()`
    `void` | `setAnld(byte[] field_67_anld)` Set the anld field for the PAP record.
    `void` | `setBrcBar(BorderCode field_65_brcBar)` Set the brcBar field for the PAP record.
    `void` | `setBrcBetween(BorderCode field_64_brcBetween)` Set the brcBetween field for the PAP record.
    `void` | `setBrcBottom(BorderCode field_62_brcBottom)` Set the brcBottom field for the PAP record.
    `void` | `setBrcl(byte field_6_brcl)` Border line style.
    `void` | `setBrcLeft(BorderCode field_61_brcLeft)` Set the brcLeft field for the PAP record.
    `void` | `setBrcp(byte field_7_brcp)` Rectangle border codes.
    `void` | `setBrcRight(BorderCode field_63_brcRight)` Set the brcRight field for the PAP record.
    `void` | `setBrcTop(BorderCode field_60_brcTop)` Set the brcTop field for the PAP record.
    `void` | `setDcs(DropCapSpecifier field_28_dcs)` Set the dcs field for the PAP record.
    `void` | `setDttmPropRMark(DateAndTime field_71_dttmPropRMark)` Set the dttmPropRMark field for the PAP record.
    `void` | `setDxaAbs(int field_17_dxaAbs)` Set the dxaAbs field for the PAP record.
    `void` | `setDxaFromText(int field_30_dxaFromText)` Horizontal distance between text and absolutely positioned object.
    `void` | `setDxaLeft(int field_57_dxaLeft)` Set the dxaLeft field for the PAP record.
    `void` | `setDxaLeft1(int field_58_dxaLeft1)` Set the dxaLeft1 field for the PAP record.
    `void` | `setDxaRight(int field_56_dxaRight)` Set the dxaRight field for the PAP record.
    `void` | `setDxaWidth(int field_19_dxaWidth)` Set the dxaWidth field for the PAP record.
    `void` | `setDxcLeft(short field_52_dxcLeft)` Left indent in character units.
    `void` | `setDxcLeft1(short field_53_dxcLeft1)` First line indent in character units.
    `void` | `setDxcRight(short field_51_dxcRight)` Right indent in character units.
    `void` | `setDyaAbs(int field_18_dyaAbs)` Set the dyaAbs field for the PAP record.
    `void` | `setDyaAfter(int field_13_dyaAfter)` Space after paragraph.
    `void` | `setDyaBefore(int field_12_dyaBefore)` Space before paragraph.
    `void` | `setDyaFromText(int field_29_dyaFromText)` Vertical distance between text and absolutely positioned object.
    `void` | `setDyaHeight(int field_26_dyaHeight)` Set the dyaHeight field for the PAP record.
    `void` | `setFAdjustRight(boolean field_46_fAdjustRight)` Set the fAdjustRight field for the PAP record.
    `void` | `setFAutoSpaceDE(boolean field_37_fAutoSpaceDE)` auto space East Asian and alphabetic characters.
    `void` | `setFAutoSpaceDN(boolean field_38_fAutoSpaceDN)` auto space East Asian and numeric characters.
    `void` | `setFBackward(boolean value)` Sets the fBackward field value.
    `void` | `setFBiDi(boolean field_42_fBiDi)` Set the fBiDi field for the PAP record.
    `void` | `setFBrLnAbove(boolean field_20_fBrLnAbove)` Set the fBrLnAbove field for the PAP record.
    `void` | `setFBrLnBelow(boolean field_21_fBrLnBelow)` Set the fBrLnBelow field for the PAP record.
    `void` | `setFCrLf(boolean field_44_fCrLf)` Set the fCrLf field for the PAP record.
    `void` | `setFDyaAfterAuto(boolean field_55_fDyaAfterAuto)` Vertical spacing after is automatic.
    `void` | `setFDyaBeforeAuto(boolean field_54_fDyaBeforeAuto)` Vertical spacing before is automatic.
    `void` | `setFInnerTableCell(boolean field_48_fInnerTableCell)` When 1, the end of paragraph mark is really an end of cell mark for a nested table cell.
    `void` | `setFInTable(boolean field_14_fInTable)` Paragraph is in table flag.
    `void` | `setFinTableW97(boolean field_15_finTableW97)` Archaic paragraph is in table flag.
    `void` | `setFKeep(boolean field_3_fKeep)` Set the fKeep field for the PAP record.
    `void` | `setFKeepFollow(boolean field_4_fKeepFollow)` Set the fKeepFollow field for the PAP record.
    `void` | `setFKinsoku(boolean field_33_fKinsoku)` apply Kinsoku rules when performing line wrapping.
    `void` | `setFLocked(boolean field_31_fLocked)` Anchor of an absolutely positioned frame is locked.
    `void` | `setFMinHeight(boolean field_27_fMinHeight)` Minimum height is exact or auto.
    `void` | `setFNoAllowOverlap(boolean field_77_fNoAllowOverlap)` When 1, absolutely positioned paragraph cannot overlap with another paragraph.
    `void` | `setFNoAutoHyph(boolean field_25_fNoAutoHyph)` Set the fNoAutoHyph field for the PAP record.
    `void` | `setFNoLnn(boolean field_10_fNoLnn)` No line numbering.
    `void` | `setFNumRMIns(boolean field_43_fNumRMIns)` Set the fNumRMIns field for the PAP record.
    `void` | `setFontAlign(short field_40_fontAlign)` Used internally by Word.
    `void` | `setFOpenTch(boolean field_49_fOpenTch)` Ensure the Table Cell char doesn't show up as zero height.
    `void` | `setFOverflowPunct(boolean field_35_fOverflowPunct)` apply overflow punctuation rules when performing line wrapping.
    `void` | `setFPageBreakBefore(boolean field_5_fPageBreakBefore)` Set the fPageBreakBefore field for the PAP record.
    `void` | `setFPropRMark(boolean field_69_fPropRMark)` Set the fPropRMark field for the PAP record.
    `void` | `setFRotateFont(boolean value)` Sets the fRotateFont field value.
    `void` | `setFSideBySide(boolean field_2_fSideBySide)` Set the fSideBySide field for the PAP record.
    `void` | `setFTopLinePunct(boolean field_36_fTopLinePunct)` perform top line punctuation processing.
    `void` | `setFTtp(boolean field_16_fTtp)` Table trailer paragraph (last in table row).
    `void` | `setFTtpEmbedded(boolean field_50_fTtpEmbedded)` Word 97 compatibility indicates this end of paragraph mark is really an end of row marker for a nested table.
    `void` | `setFUsePgsuSettings(boolean field_45_fUsePgsuSettings)` Set the fUsePgsuSettings field for the PAP record.
    `void` | `setFVertical(boolean value)` Sets the fVertical field value.
    `void` | `setFWidowControl(boolean field_32_fWidowControl)` 1, Word will prevent widowed lines in this paragraph from being placed at the beginning of a page.
    `void` | `setFWordWrap(boolean field_34_fWordWrap)` perform word wrap.
    `void` | `setIbstPropRMark(int field_70_ibstPropRMark)` Set the ibstPropRMark field for the PAP record.
    `void` | `setIlfo(int field_9_ilfo)` "A 16-bit signed integer value that is used to determine which list contains the paragraph.
    `void` | `setIlvl(byte field_8_ilvl)` List level if non-zero.
    `void` | `setIpgp(long field_78_ipgp)` HTML DIV ID for this paragraph.
    `void` | `setIstd(int field_1_istd)` Index to style descriptor.
    `void` | `setItap(int field_47_itap)` Table nesting level.
    `void` | `setItbdMac(int field_72_itbdMac)` Number of tabs stops defined for paragraph.
    `void` | `setJc(byte field_59_jc)` Set the jc field for the PAP record.
    `void` | `setLspd(LineSpacingDescriptor field_11_lspd)` Line spacing descriptor.
    `void` | `setLvl(byte field_41_lvl)` Outline level.
    `void` | `setNumrm(byte[] field_75_numrm)` Set the numrm field for the PAP record.
    `void` | `setPcHorz(byte field_23_pcHorz)` Set the pcHorz field for the PAP record.
    `void` | `setPcVert(byte field_22_pcVert)` Set the pcVert field for the PAP record.
    `void` | `setPhe(byte[] field_68_phe)` Set the phe field for the PAP record.
    `void` | `setPtap(byte[] field_76_ptap)` Set the ptap field for the PAP record.
    `void` | `setRgdxaTab(int[] field_73_rgdxaTab)` Array of positions of itbdMac tab stops.
    `void` | `setRgtbd(TabDescriptor[] field_74_rgtbd)` Array of itbdMac tab descriptors.
    `void` | `setRsid(long field_79_rsid)` Save ID for last time this PAP was revised.
    `void` | `setShd(ShadingDescriptor field_66_shd)` Set the shd field for the PAP record.
    `void` | `setWAlignFont(int field_39_wAlignFont)` Set the wAlignFont field for the PAP record.
    `void` | `setWr(byte field_24_wr)` Set the wr field for the PAP record.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### BRCL_SINGLE

          protected static final byte BRCL_SINGLE

      See Also:
        Constant Field Values

    - #### BRCL_THICK

          protected static final byte BRCL_THICK

      See Also:
        Constant Field Values

    - #### BRCL_DOUBLE

          protected static final byte BRCL_DOUBLE

      See Also:
        Constant Field Values

    - #### BRCL_SHADOW

          protected static final byte BRCL_SHADOW

      See Also:
        Constant Field Values

    - #### BRCP_NONE

          protected static final byte BRCP_NONE

      See Also:
        Constant Field Values

    - #### BRCP_BORDER_ABOVE

          protected static final byte BRCP_BORDER_ABOVE

      See Also:
        Constant Field Values

    - #### BRCP_BORDER_BELOW

          protected static final byte BRCP_BORDER_BELOW

      See Also:
        Constant Field Values

    - #### BRCP_BOX_AROUND

          protected static final byte BRCP_BOX_AROUND

      See Also:
        Constant Field Values

    - #### BRCP_BAR_TO_LEFT_OF_PARAGRAPH

          protected static final byte BRCP_BAR_TO_LEFT_OF_PARAGRAPH

      See Also:
        Constant Field Values

    - #### FMINHEIGHT_EXACT

          protected static final boolean FMINHEIGHT_EXACT

      See Also:
        Constant Field Values

    - #### FMINHEIGHT_AT_LEAST

          protected static final boolean FMINHEIGHT_AT_LEAST

      See Also:
        Constant Field Values

    - #### WALIGNFONT_HANGING

          protected static final byte WALIGNFONT_HANGING

      See Also:
        Constant Field Values

    - #### WALIGNFONT_CENTERED

          protected static final byte WALIGNFONT_CENTERED

      See Also:
        Constant Field Values

    - #### WALIGNFONT_ROMAN

          protected static final byte WALIGNFONT_ROMAN

      See Also:
        Constant Field Values

    - #### WALIGNFONT_VARIABLE

          protected static final byte WALIGNFONT_VARIABLE

      See Also:
        Constant Field Values

    - #### WALIGNFONT_AUTO

          protected static final byte WALIGNFONT_AUTO

      See Also:
        Constant Field Values

    - #### field_1_istd

          protected int field_1_istd

    - #### field_2_fSideBySide

          protected boolean field_2_fSideBySide

    - #### field_3_fKeep

          protected boolean field_3_fKeep

    - #### field_4_fKeepFollow

          protected boolean field_4_fKeepFollow

    - #### field_5_fPageBreakBefore

          protected boolean field_5_fPageBreakBefore

    - #### field_6_brcl

          protected byte field_6_brcl

    - #### field_7_brcp

          protected byte field_7_brcp

    - #### field_8_ilvl

          protected byte field_8_ilvl

    - #### field_9_ilfo

          protected int field_9_ilfo

    - #### field_10_fNoLnn

          protected boolean field_10_fNoLnn

    - #### field_11_lspd

          protected LineSpacingDescriptor field_11_lspd

    - #### field_12_dyaBefore

          protected int field_12_dyaBefore

    - #### field_13_dyaAfter

          protected int field_13_dyaAfter

    - #### field_14_fInTable

          protected boolean field_14_fInTable

    - #### field_15_finTableW97

          protected boolean field_15_finTableW97

    - #### field_16_fTtp

          protected boolean field_16_fTtp

    - #### field_17_dxaAbs

          protected int field_17_dxaAbs

    - #### field_18_dyaAbs

          protected int field_18_dyaAbs

    - #### field_19_dxaWidth

          protected int field_19_dxaWidth

    - #### field_20_fBrLnAbove

          protected boolean field_20_fBrLnAbove

    - #### field_21_fBrLnBelow

          protected boolean field_21_fBrLnBelow

    - #### field_22_pcVert

          protected byte field_22_pcVert

    - #### field_23_pcHorz

          protected byte field_23_pcHorz

    - #### field_24_wr

          protected byte field_24_wr

    - #### field_25_fNoAutoHyph

          protected boolean field_25_fNoAutoHyph

    - #### field_26_dyaHeight

          protected int field_26_dyaHeight

    - #### field_27_fMinHeight

          protected boolean field_27_fMinHeight

    - #### field_28_dcs

          protected DropCapSpecifier field_28_dcs

    - #### field_29_dyaFromText

          protected int field_29_dyaFromText

    - #### field_30_dxaFromText

          protected int field_30_dxaFromText

    - #### field_31_fLocked

          protected boolean field_31_fLocked

    - #### field_32_fWidowControl

          protected boolean field_32_fWidowControl

    - #### field_33_fKinsoku

          protected boolean field_33_fKinsoku

    - #### field_34_fWordWrap

          protected boolean field_34_fWordWrap

    - #### field_35_fOverflowPunct

          protected boolean field_35_fOverflowPunct

    - #### field_36_fTopLinePunct

          protected boolean field_36_fTopLinePunct

    - #### field_37_fAutoSpaceDE

          protected boolean field_37_fAutoSpaceDE

    - #### field_38_fAutoSpaceDN

          protected boolean field_38_fAutoSpaceDN

    - #### field_39_wAlignFont

          protected int field_39_wAlignFont

    - #### field_40_fontAlign

          protected short field_40_fontAlign

    - #### field_41_lvl

          protected byte field_41_lvl

    - #### field_42_fBiDi

          protected boolean field_42_fBiDi

    - #### field_43_fNumRMIns

          protected boolean field_43_fNumRMIns

    - #### field_44_fCrLf

          protected boolean field_44_fCrLf

    - #### field_45_fUsePgsuSettings

          protected boolean field_45_fUsePgsuSettings

    - #### field_46_fAdjustRight

          protected boolean field_46_fAdjustRight

    - #### field_47_itap

          protected int field_47_itap

    - #### field_48_fInnerTableCell

          protected boolean field_48_fInnerTableCell

    - #### field_49_fOpenTch

          protected boolean field_49_fOpenTch

    - #### field_50_fTtpEmbedded

          protected boolean field_50_fTtpEmbedded

    - #### field_51_dxcRight

          protected short field_51_dxcRight

    - #### field_52_dxcLeft

          protected short field_52_dxcLeft

    - #### field_53_dxcLeft1

          protected short field_53_dxcLeft1

    - #### field_54_fDyaBeforeAuto

          protected boolean field_54_fDyaBeforeAuto

    - #### field_55_fDyaAfterAuto

          protected boolean field_55_fDyaAfterAuto

    - #### field_56_dxaRight

          protected int field_56_dxaRight

    - #### field_57_dxaLeft

          protected int field_57_dxaLeft

    - #### field_58_dxaLeft1

          protected int field_58_dxaLeft1

    - #### field_59_jc

          protected byte field_59_jc

    - #### field_60_brcTop

          protected BorderCode field_60_brcTop

    - #### field_61_brcLeft

          protected BorderCode field_61_brcLeft

    - #### field_62_brcBottom

          protected BorderCode field_62_brcBottom

    - #### field_63_brcRight

          protected BorderCode field_63_brcRight

    - #### field_64_brcBetween

          protected BorderCode field_64_brcBetween

    - #### field_65_brcBar

          protected BorderCode field_65_brcBar

    - #### field_66_shd

          protected ShadingDescriptor field_66_shd

    - #### field_67_anld

          protected byte[] field_67_anld

    - #### field_68_phe

          protected byte[] field_68_phe

    - #### field_69_fPropRMark

          protected boolean field_69_fPropRMark

    - #### field_70_ibstPropRMark

          protected int field_70_ibstPropRMark

    - #### field_71_dttmPropRMark

          protected DateAndTime field_71_dttmPropRMark

    - #### field_72_itbdMac

          protected int field_72_itbdMac

    - #### field_73_rgdxaTab

          protected int[] field_73_rgdxaTab

    - #### field_74_rgtbd

          protected TabDescriptor[] field_74_rgtbd

    - #### field_75_numrm

          protected byte[] field_75_numrm

    - #### field_76_ptap

          protected byte[] field_76_ptap

    - #### field_77_fNoAllowOverlap

          protected boolean field_77_fNoAllowOverlap

    - #### field_78_ipgp

          protected long field_78_ipgp

    - #### field_79_rsid

          protected long field_79_rsid

  - ### Constructor Detail

    - #### PAPAbstractType

          protected PAPAbstractType()

    - #### PAPAbstractType

          protected PAPAbstractType(PAPAbstractType other)

  - ### Method Detail

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getIstd

          @Internal
          public int getIstd()

      Index to style descriptor.

    - #### setIstd

          @Internal
          public void setIstd(int field_1_istd)

      Index to style descriptor.

    - #### getFSideBySide

          @Internal
          public boolean getFSideBySide()

      Get the fSideBySide field for the PAP record.

    - #### setFSideBySide

          @Internal
          public void setFSideBySide(boolean field_2_fSideBySide)

      Set the fSideBySide field for the PAP record.

    - #### getFKeep

          @Internal
          public boolean getFKeep()

      Get the fKeep field for the PAP record.

    - #### setFKeep

          @Internal
          public void setFKeep(boolean field_3_fKeep)

      Set the fKeep field for the PAP record.

    - #### getFKeepFollow

          @Internal
          public boolean getFKeepFollow()

      Get the fKeepFollow field for the PAP record.

    - #### setFKeepFollow

          @Internal
          public void setFKeepFollow(boolean field_4_fKeepFollow)

      Set the fKeepFollow field for the PAP record.

    - #### getFPageBreakBefore

          @Internal
          public boolean getFPageBreakBefore()

      Get the fPageBreakBefore field for the PAP record.

    - #### setFPageBreakBefore

          @Internal
          public void setFPageBreakBefore(boolean field_5_fPageBreakBefore)

      Set the fPageBreakBefore field for the PAP record.

    - #### getBrcl

          @Internal
          public byte getBrcl()

      Border line style.
      Returns:
        One of
    - `BRCL_SINGLE`
    - `BRCL_THICK`
    - `BRCL_DOUBLE`
    - `BRCL_SHADOW`

    - #### setBrcl

          @Internal
          public void setBrcl(byte field_6_brcl)

      Border line style.
      Parameters:
        `field_6_brcl` - One of
    - `BRCL_SINGLE`
    - `BRCL_THICK`
    - `BRCL_DOUBLE`
    - `BRCL_SHADOW`

    - #### getBrcp

          @Internal
          public byte getBrcp()

      Rectangle border codes.
      Returns:
        One of
    - `BRCP_NONE`
    - `BRCP_BORDER_ABOVE`
    - `BRCP_BORDER_BELOW`
    - `BRCP_BOX_AROUND`
    - `BRCP_BAR_TO_LEFT_OF_PARAGRAPH`

    - #### setBrcp

          @Internal
          public void setBrcp(byte field_7_brcp)

      Rectangle border codes.
      Parameters:
        `field_7_brcp` - One of
    - `BRCP_NONE`
    - `BRCP_BORDER_ABOVE`
    - `BRCP_BORDER_BELOW`
    - `BRCP_BOX_AROUND`
    - `BRCP_BAR_TO_LEFT_OF_PARAGRAPH`

    - #### getIlvl

          @Internal
          public byte getIlvl()

      List level if non-zero.

    - #### setIlvl

          @Internal
          public void setIlvl(byte field_8_ilvl)

      List level if non-zero.

    - #### getIlfo

          @Internal
          public int getIlfo()

      "A 16-bit signed integer value that is used to determine which list contains the paragraph. This value MUST be one of the following: 0x0000 -- This paragraph is not in a list, and any list formatting on the paragraph is removed. 0x0001 - 0x07FE -- The value is a 1-based index into PlfLfo.rgLfo. The LFO at this index defines the list that this paragraph is in. 0xF801 -- This paragraph is not in a list. 0xF802 - 0xFFFF -- The value is the negation of a 1-based index into PlfLfo.rgLfo. The LFO at this index defines the list that this paragraph is in. The logical left indentation (see sprmPDxaLeft) and the logical left first line indentation (see sprmPDxaLeft1) of the paragraph MUST be preserved despite any list formatting. By default, a paragraph is not in a list." Quote from [MS-DOC] -- v20110315, page 125

    - #### setIlfo

          @Internal
          public void setIlfo(int field_9_ilfo)

      "A 16-bit signed integer value that is used to determine which list contains the paragraph. This value MUST be one of the following: 0x0000 -- This paragraph is not in a list, and any list formatting on the paragraph is removed. 0x0001 - 0x07FE -- The value is a 1-based index into PlfLfo.rgLfo. The LFO at this index defines the list that this paragraph is in. 0xF801 -- This paragraph is not in a list. 0xF802 - 0xFFFF -- The value is the negation of a 1-based index into PlfLfo.rgLfo. The LFO at this index defines the list that this paragraph is in. The logical left indentation (see sprmPDxaLeft) and the logical left first line indentation (see sprmPDxaLeft1) of the paragraph MUST be preserved despite any list formatting. By default, a paragraph is not in a list." Quote from [MS-DOC] -- v20110315, page 125

    - #### getFNoLnn

          @Internal
          public boolean getFNoLnn()

      No line numbering.

    - #### setFNoLnn

          @Internal
          public void setFNoLnn(boolean field_10_fNoLnn)

      No line numbering.

    - #### getLspd

          @Internal
          public LineSpacingDescriptor getLspd()

      Line spacing descriptor.

    - #### setLspd

          @Internal
          public void setLspd(LineSpacingDescriptor field_11_lspd)

      Line spacing descriptor.

    - #### getDyaBefore

          @Internal
          public int getDyaBefore()

      Space before paragraph.

    - #### setDyaBefore

          @Internal
          public void setDyaBefore(int field_12_dyaBefore)

      Space before paragraph.

    - #### getDyaAfter

          @Internal
          public int getDyaAfter()

      Space after paragraph.

    - #### setDyaAfter

          @Internal
          public void setDyaAfter(int field_13_dyaAfter)

      Space after paragraph.

    - #### getFInTable

          @Internal
          public boolean getFInTable()

      Paragraph is in table flag.

    - #### setFInTable

          @Internal
          public void setFInTable(boolean field_14_fInTable)

      Paragraph is in table flag.

    - #### getFinTableW97

          @Internal
          public boolean getFinTableW97()

      Archaic paragraph is in table flag.

    - #### setFinTableW97

          @Internal
          public void setFinTableW97(boolean field_15_finTableW97)

      Archaic paragraph is in table flag.

    - #### getFTtp

          @Internal
          public boolean getFTtp()

      Table trailer paragraph (last in table row).

    - #### setFTtp

          @Internal
          public void setFTtp(boolean field_16_fTtp)

      Table trailer paragraph (last in table row).

    - #### getDxaAbs

          @Internal
          public int getDxaAbs()

      Get the dxaAbs field for the PAP record.

    - #### setDxaAbs

          @Internal
          public void setDxaAbs(int field_17_dxaAbs)

      Set the dxaAbs field for the PAP record.

    - #### getDyaAbs

          @Internal
          public int getDyaAbs()

      Get the dyaAbs field for the PAP record.

    - #### setDyaAbs

          @Internal
          public void setDyaAbs(int field_18_dyaAbs)

      Set the dyaAbs field for the PAP record.

    - #### getDxaWidth

          @Internal
          public int getDxaWidth()

      Get the dxaWidth field for the PAP record.

    - #### setDxaWidth

          @Internal
          public void setDxaWidth(int field_19_dxaWidth)

      Set the dxaWidth field for the PAP record.

    - #### getFBrLnAbove

          @Internal
          public boolean getFBrLnAbove()

      Get the fBrLnAbove field for the PAP record.

    - #### setFBrLnAbove

          @Internal
          public void setFBrLnAbove(boolean field_20_fBrLnAbove)

      Set the fBrLnAbove field for the PAP record.

    - #### getFBrLnBelow

          @Internal
          public boolean getFBrLnBelow()

      Get the fBrLnBelow field for the PAP record.

    - #### setFBrLnBelow

          @Internal
          public void setFBrLnBelow(boolean field_21_fBrLnBelow)

      Set the fBrLnBelow field for the PAP record.

    - #### getPcVert

          @Internal
          public byte getPcVert()

      Get the pcVert field for the PAP record.

    - #### setPcVert

          @Internal
          public void setPcVert(byte field_22_pcVert)

      Set the pcVert field for the PAP record.

    - #### getPcHorz

          @Internal
          public byte getPcHorz()

      Get the pcHorz field for the PAP record.

    - #### setPcHorz

          @Internal
          public void setPcHorz(byte field_23_pcHorz)

      Set the pcHorz field for the PAP record.

    - #### getWr

          @Internal
          public byte getWr()

      Get the wr field for the PAP record.

    - #### setWr

          @Internal
          public void setWr(byte field_24_wr)

      Set the wr field for the PAP record.

    - #### getFNoAutoHyph

          @Internal
          public boolean getFNoAutoHyph()

      Get the fNoAutoHyph field for the PAP record.

    - #### setFNoAutoHyph

          @Internal
          public void setFNoAutoHyph(boolean field_25_fNoAutoHyph)

      Set the fNoAutoHyph field for the PAP record.

    - #### getDyaHeight

          @Internal
          public int getDyaHeight()

      Get the dyaHeight field for the PAP record.

    - #### setDyaHeight

          @Internal
          public void setDyaHeight(int field_26_dyaHeight)

      Set the dyaHeight field for the PAP record.

    - #### getFMinHeight

          @Internal
          public boolean getFMinHeight()

      Minimum height is exact or auto.
      Returns:
        One of
    - `FMINHEIGHT_EXACT`
    - `FMINHEIGHT_AT_LEAST`

    - #### setFMinHeight

          @Internal
          public void setFMinHeight(boolean field_27_fMinHeight)

      Minimum height is exact or auto.
      Parameters:
        `field_27_fMinHeight` - One of
    - `FMINHEIGHT_EXACT`
    - `FMINHEIGHT_AT_LEAST`

    - #### getDcs

          @Internal
          public DropCapSpecifier getDcs()

      Get the dcs field for the PAP record.

    - #### setDcs

          @Internal
          public void setDcs(DropCapSpecifier field_28_dcs)

      Set the dcs field for the PAP record.

    - #### getDyaFromText

          @Internal
          public int getDyaFromText()

      Vertical distance between text and absolutely positioned object.

    - #### setDyaFromText

          @Internal
          public void setDyaFromText(int field_29_dyaFromText)

      Vertical distance between text and absolutely positioned object.

    - #### getDxaFromText

          @Internal
          public int getDxaFromText()

      Horizontal distance between text and absolutely positioned object.

    - #### setDxaFromText

          @Internal
          public void setDxaFromText(int field_30_dxaFromText)

      Horizontal distance between text and absolutely positioned object.

    - #### getFLocked

          @Internal
          public boolean getFLocked()

      Anchor of an absolutely positioned frame is locked.

    - #### setFLocked

          @Internal
          public void setFLocked(boolean field_31_fLocked)

      Anchor of an absolutely positioned frame is locked.

    - #### getFWidowControl

          @Internal
          public boolean getFWidowControl()

      1, Word will prevent widowed lines in this paragraph from being placed at the beginning of a page.

    - #### setFWidowControl

          @Internal
          public void setFWidowControl(boolean field_32_fWidowControl)

      1, Word will prevent widowed lines in this paragraph from being placed at the beginning of a page.

    - #### getFKinsoku

          @Internal
          public boolean getFKinsoku()

      apply Kinsoku rules when performing line wrapping.

    - #### setFKinsoku

          @Internal
          public void setFKinsoku(boolean field_33_fKinsoku)

      apply Kinsoku rules when performing line wrapping.

    - #### getFWordWrap

          @Internal
          public boolean getFWordWrap()

      perform word wrap.

    - #### setFWordWrap

          @Internal
          public void setFWordWrap(boolean field_34_fWordWrap)

      perform word wrap.

    - #### getFOverflowPunct

          @Internal
          public boolean getFOverflowPunct()

      apply overflow punctuation rules when performing line wrapping.

    - #### setFOverflowPunct

          @Internal
          public void setFOverflowPunct(boolean field_35_fOverflowPunct)

      apply overflow punctuation rules when performing line wrapping.

    - #### getFTopLinePunct

          @Internal
          public boolean getFTopLinePunct()

      perform top line punctuation processing.

    - #### setFTopLinePunct

          @Internal
          public void setFTopLinePunct(boolean field_36_fTopLinePunct)

      perform top line punctuation processing.

    - #### getFAutoSpaceDE

          @Internal
          public boolean getFAutoSpaceDE()

      auto space East Asian and alphabetic characters.

    - #### setFAutoSpaceDE

          @Internal
          public void setFAutoSpaceDE(boolean field_37_fAutoSpaceDE)

      auto space East Asian and alphabetic characters.

    - #### getFAutoSpaceDN

          @Internal
          public boolean getFAutoSpaceDN()

      auto space East Asian and numeric characters.

    - #### setFAutoSpaceDN

          @Internal
          public void setFAutoSpaceDN(boolean field_38_fAutoSpaceDN)

      auto space East Asian and numeric characters.

    - #### getWAlignFont

          @Internal
          public int getWAlignFont()

      Get the wAlignFont field for the PAP record.
      Returns:
        One of
    - `WALIGNFONT_HANGING`
    - `WALIGNFONT_CENTERED`
    - `WALIGNFONT_ROMAN`
    - `WALIGNFONT_VARIABLE`
    - `WALIGNFONT_AUTO`

    - #### setWAlignFont

          @Internal
          public void setWAlignFont(int field_39_wAlignFont)

      Set the wAlignFont field for the PAP record.
      Parameters:
        `field_39_wAlignFont` - One of
    - `WALIGNFONT_HANGING`
    - `WALIGNFONT_CENTERED`
    - `WALIGNFONT_ROMAN`
    - `WALIGNFONT_VARIABLE`
    - `WALIGNFONT_AUTO`

    - #### getFontAlign

          @Internal
          public short getFontAlign()

      Used internally by Word.

    - #### setFontAlign

          @Internal
          public void setFontAlign(short field_40_fontAlign)

      Used internally by Word.

    - #### getLvl

          @Internal
          public byte getLvl()

      Outline level.

    - #### setLvl

          @Internal
          public void setLvl(byte field_41_lvl)

      Outline level.

    - #### getFBiDi

          @Internal
          public boolean getFBiDi()

      Get the fBiDi field for the PAP record.

    - #### setFBiDi

          @Internal
          public void setFBiDi(boolean field_42_fBiDi)

      Set the fBiDi field for the PAP record.

    - #### getFNumRMIns

          @Internal
          public boolean getFNumRMIns()

      Get the fNumRMIns field for the PAP record.

    - #### setFNumRMIns

          @Internal
          public void setFNumRMIns(boolean field_43_fNumRMIns)

      Set the fNumRMIns field for the PAP record.

    - #### getFCrLf

          @Internal
          public boolean getFCrLf()

      Get the fCrLf field for the PAP record.

    - #### setFCrLf

          @Internal
          public void setFCrLf(boolean field_44_fCrLf)

      Set the fCrLf field for the PAP record.

    - #### getFUsePgsuSettings

          @Internal
          public boolean getFUsePgsuSettings()

      Get the fUsePgsuSettings field for the PAP record.

    - #### setFUsePgsuSettings

          @Internal
          public void setFUsePgsuSettings(boolean field_45_fUsePgsuSettings)

      Set the fUsePgsuSettings field for the PAP record.

    - #### getFAdjustRight

          @Internal
          public boolean getFAdjustRight()

      Get the fAdjustRight field for the PAP record.

    - #### setFAdjustRight

          @Internal
          public void setFAdjustRight(boolean field_46_fAdjustRight)

      Set the fAdjustRight field for the PAP record.

    - #### getItap

          @Internal
          public int getItap()

      Table nesting level.

    - #### setItap

          @Internal
          public void setItap(int field_47_itap)

      Table nesting level.

    - #### getFInnerTableCell

          @Internal
          public boolean getFInnerTableCell()

      When 1, the end of paragraph mark is really an end of cell mark for a nested table cell.

    - #### setFInnerTableCell

          @Internal
          public void setFInnerTableCell(boolean field_48_fInnerTableCell)

      When 1, the end of paragraph mark is really an end of cell mark for a nested table cell.

    - #### getFOpenTch

          @Internal
          public boolean getFOpenTch()

      Ensure the Table Cell char doesn't show up as zero height.

    - #### setFOpenTch

          @Internal
          public void setFOpenTch(boolean field_49_fOpenTch)

      Ensure the Table Cell char doesn't show up as zero height.

    - #### getFTtpEmbedded

          @Internal
          public boolean getFTtpEmbedded()

      Word 97 compatibility indicates this end of paragraph mark is really an end of row marker for a nested table.

    - #### setFTtpEmbedded

          @Internal
          public void setFTtpEmbedded(boolean field_50_fTtpEmbedded)

      Word 97 compatibility indicates this end of paragraph mark is really an end of row marker for a nested table.

    - #### getDxcRight

          @Internal
          public short getDxcRight()

      Right indent in character units.

    - #### setDxcRight

          @Internal
          public void setDxcRight(short field_51_dxcRight)

      Right indent in character units.

    - #### getDxcLeft

          @Internal
          public short getDxcLeft()

      Left indent in character units.

    - #### setDxcLeft

          @Internal
          public void setDxcLeft(short field_52_dxcLeft)

      Left indent in character units.

    - #### getDxcLeft1

          @Internal
          public short getDxcLeft1()

      First line indent in character units.

    - #### setDxcLeft1

          @Internal
          public void setDxcLeft1(short field_53_dxcLeft1)

      First line indent in character units.

    - #### getFDyaBeforeAuto

          @Internal
          public boolean getFDyaBeforeAuto()

      Vertical spacing before is automatic.

    - #### setFDyaBeforeAuto

          @Internal
          public void setFDyaBeforeAuto(boolean field_54_fDyaBeforeAuto)

      Vertical spacing before is automatic.

    - #### getFDyaAfterAuto

          @Internal
          public boolean getFDyaAfterAuto()

      Vertical spacing after is automatic.

    - #### setFDyaAfterAuto

          @Internal
          public void setFDyaAfterAuto(boolean field_55_fDyaAfterAuto)

      Vertical spacing after is automatic.

    - #### getDxaRight

          @Internal
          public int getDxaRight()

      Get the dxaRight field for the PAP record.

    - #### setDxaRight

          @Internal
          public void setDxaRight(int field_56_dxaRight)

      Set the dxaRight field for the PAP record.

    - #### getDxaLeft

          @Internal
          public int getDxaLeft()

      Get the dxaLeft field for the PAP record.

    - #### setDxaLeft

          @Internal
          public void setDxaLeft(int field_57_dxaLeft)

      Set the dxaLeft field for the PAP record.

    - #### getDxaLeft1

          @Internal
          public int getDxaLeft1()

      Get the dxaLeft1 field for the PAP record.

    - #### setDxaLeft1

          @Internal
          public void setDxaLeft1(int field_58_dxaLeft1)

      Set the dxaLeft1 field for the PAP record.

    - #### getJc

          @Internal
          public byte getJc()

      Get the jc field for the PAP record.

    - #### setJc

          @Internal
          public void setJc(byte field_59_jc)

      Set the jc field for the PAP record.

    - #### getBrcTop

          @Internal
          public BorderCode getBrcTop()

      Get the brcTop field for the PAP record.

    - #### setBrcTop

          @Internal
          public void setBrcTop(BorderCode field_60_brcTop)

      Set the brcTop field for the PAP record.

    - #### getBrcLeft

          @Internal
          public BorderCode getBrcLeft()

      Get the brcLeft field for the PAP record.

    - #### setBrcLeft

          @Internal
          public void setBrcLeft(BorderCode field_61_brcLeft)

      Set the brcLeft field for the PAP record.

    - #### getBrcBottom

          @Internal
          public BorderCode getBrcBottom()

      Get the brcBottom field for the PAP record.

    - #### setBrcBottom

          @Internal
          public void setBrcBottom(BorderCode field_62_brcBottom)

      Set the brcBottom field for the PAP record.

    - #### getBrcRight

          @Internal
          public BorderCode getBrcRight()

      Get the brcRight field for the PAP record.

    - #### setBrcRight

          @Internal
          public void setBrcRight(BorderCode field_63_brcRight)

      Set the brcRight field for the PAP record.

    - #### getBrcBetween

          @Internal
          public BorderCode getBrcBetween()

      Get the brcBetween field for the PAP record.

    - #### setBrcBetween

          @Internal
          public void setBrcBetween(BorderCode field_64_brcBetween)

      Set the brcBetween field for the PAP record.

    - #### getBrcBar

          @Internal
          public BorderCode getBrcBar()

      Get the brcBar field for the PAP record.

    - #### setBrcBar

          @Internal
          public void setBrcBar(BorderCode field_65_brcBar)

      Set the brcBar field for the PAP record.

    - #### getShd

          @Internal
          public ShadingDescriptor getShd()

      Get the shd field for the PAP record.

    - #### setShd

          @Internal
          public void setShd(ShadingDescriptor field_66_shd)

      Set the shd field for the PAP record.

    - #### getAnld

          @Internal
          public byte[] getAnld()

      Get the anld field for the PAP record.

    - #### setAnld

          @Internal
          public void setAnld(byte[] field_67_anld)

      Set the anld field for the PAP record.

    - #### getPhe

          @Internal
          public byte[] getPhe()

      Get the phe field for the PAP record.

    - #### setPhe

          @Internal
          public void setPhe(byte[] field_68_phe)

      Set the phe field for the PAP record.

    - #### getFPropRMark

          @Internal
          public boolean getFPropRMark()

      Get the fPropRMark field for the PAP record.

    - #### setFPropRMark

          @Internal
          public void setFPropRMark(boolean field_69_fPropRMark)

      Set the fPropRMark field for the PAP record.

    - #### getIbstPropRMark

          @Internal
          public int getIbstPropRMark()

      Get the ibstPropRMark field for the PAP record.

    - #### setIbstPropRMark

          @Internal
          public void setIbstPropRMark(int field_70_ibstPropRMark)

      Set the ibstPropRMark field for the PAP record.

    - #### getDttmPropRMark

          @Internal
          public DateAndTime getDttmPropRMark()

      Get the dttmPropRMark field for the PAP record.

    - #### setDttmPropRMark

          @Internal
          public void setDttmPropRMark(DateAndTime field_71_dttmPropRMark)

      Set the dttmPropRMark field for the PAP record.

    - #### getItbdMac

          @Internal
          public int getItbdMac()

      Number of tabs stops defined for paragraph. Must be >= 0 and <= 64..

    - #### setItbdMac

          @Internal
          public void setItbdMac(int field_72_itbdMac)

      Number of tabs stops defined for paragraph. Must be >= 0 and <= 64..

    - #### getRgdxaTab

          @Internal
          public int[] getRgdxaTab()

      Array of positions of itbdMac tab stops. itbdMax==64.

    - #### setRgdxaTab

          @Internal
          public void setRgdxaTab(int[] field_73_rgdxaTab)

      Array of positions of itbdMac tab stops. itbdMax==64.

    - #### getRgtbd

          @Internal
          public TabDescriptor[] getRgtbd()

      Array of itbdMac tab descriptors.

    - #### setRgtbd

          @Internal
          public void setRgtbd(TabDescriptor[] field_74_rgtbd)

      Array of itbdMac tab descriptors.

    - #### getNumrm

          @Internal
          public byte[] getNumrm()

      Get the numrm field for the PAP record.

    - #### setNumrm

          @Internal
          public void setNumrm(byte[] field_75_numrm)

      Set the numrm field for the PAP record.

    - #### getPtap

          @Internal
          public byte[] getPtap()

      Get the ptap field for the PAP record.

    - #### setPtap

          @Internal
          public void setPtap(byte[] field_76_ptap)

      Set the ptap field for the PAP record.

    - #### getFNoAllowOverlap

          @Internal
          public boolean getFNoAllowOverlap()

      When 1, absolutely positioned paragraph cannot overlap with another paragraph.

    - #### setFNoAllowOverlap

          @Internal
          public void setFNoAllowOverlap(boolean field_77_fNoAllowOverlap)

      When 1, absolutely positioned paragraph cannot overlap with another paragraph.

    - #### getIpgp

          @Internal
          public long getIpgp()

      HTML DIV ID for this paragraph.

    - #### setIpgp

          @Internal
          public void setIpgp(long field_78_ipgp)

      HTML DIV ID for this paragraph.

    - #### getRsid

          @Internal
          public long getRsid()

      Save ID for last time this PAP was revised.

    - #### setRsid

          @Internal
          public void setRsid(long field_79_rsid)

      Save ID for last time this PAP was revised.

    - #### setFVertical

          @Internal
          public void setFVertical(boolean value)

      Sets the fVertical field value.

    - #### isFVertical

          @Internal
          public boolean isFVertical()

      Returns:
        the fVertical field value.

    - #### setFBackward

          @Internal
          public void setFBackward(boolean value)

      Sets the fBackward field value.

    - #### isFBackward

          @Internal
          public boolean isFBackward()

      Returns:
        the fBackward field value.

    - #### setFRotateFont

          @Internal
          public void setFRotateFont(boolean value)

      Sets the fRotateFont field value.

    - #### isFRotateFont

          @Internal
          public boolean isFRotateFont()

      Returns:
        the fRotateFont field value.

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.